
//sValidation=nyfjs
//sCaption=Copy selected Html contents
//sHint=Copy selected HTML content to clipboard with images cached in TEMP folder
//sCategory=
//sCondition=CURDB; DBRW; OUTLINE; CURINFOITEM
//sID=p.CopySelHtml
//sAppVerMin=7.0
//sAuthor=wjjsoft

/////////////////////////////////////////////////////////////////////
// Extension scripts for myBase Desktop v7.x
// Copyright 2016 Wjj Software. All rights Reserved.
// Website: www.wjjsoft.com  Contact: info@wjjsoft.com
/////////////////////////////////////////////////////////////////////
// This code is property of Wjj Software (WJJSOFT). You may not use it
// for any commercial purpose without preceding consent from authors.
/////////////////////////////////////////////////////////////////////

var _lc=function(sTag, sDef){return plugin.getLocaleMsg(sTag, sDef);};
var _lc2=function(sTag, sDef){return _lc(plugin.getLocaleID()+'.'+sTag, sDef);};

var _trim=function(s){return (s||'').replace(/^\s+|\s+$/g, '');};
var _trim_cr=function(s){return (s||'').replace(/\r+$/g, '');};

try{

	var xNyf=new CNyfDb(-1);
	if(xNyf.isOpen()){

		plugin.initProgressRange(plugin.getScriptTitle(), 0);

		{
			//2016.4.14 invoke the common functions predefined for plugins;
			var xFn=new CLocalFile(new CLocalFile(plugin.getScriptFile()).getDirectory(false), 'comutils.js');
			var sCode=xFn.loadText('auto');
			if(sCode){
				eval.call(null, sCode);
			}
		}

		var sTmpDir=platform.getTempFolder();
		var sImgDirName='__nyf7_clip_images';
		var xImgDir=new CLocalDir(sTmpDir, sImgDirName);

		if(xImgDir.exists()){
			var vFiles=xImgDir.listFiles();
			for(var i in vFiles){
				var xImgFn=new CLocalFile(xImgDir.toString(), vFiles[i]);
				xImgFn.remove();
			}
		}else{
			var tmp=new CLocalDir(sTmpDir);
			tmp.createDirectory(sImgDirName);
		}

		var sCurDocPath=plugin.getCurInfoItem();
		if(sCurDocPath){
			var sHtml=plugin.getSelectedText(-1, true), sTxt=plugin.getSelectedText(-1, false);
			{
				sHtml=substituteUrisWithinHtml(sHtml, 'img,link', function(sObj, sTagName){
					var u=sObj.toString();

					var bContinue=plugin.ctrlProgressBar(u, 1, true);
					//if(!bContinue) return true;

					var m=u.match(/(data:image\/)(gif|jpg|png|bmp|tif)(;base64,)/i);
					if(m && m[1] && m[2] && m[3]){

						var sExt=m[2], sDat=u.replace(m[0], ''), sTmpFn=platform.getTempFile(xImgDir.toString(), 'image_', sExt);
						var ba=new CByteArray(sDat, 'base64');
						var nBytes=ba.saveToFile(sTmpFn);
						if(nBytes>0){
							platform.deferDeleteFile(sTmpFn);
							u=urlFromLocalFile(sTmpFn);
						}

					//}else if(u.search(/[\/\\]/)<0){
					}else if(u.search(/[:\?\*\|\/\\<>]/)<0){ //for linked objs, possibly saved in the attachments section;

						var xSsgFn=new CLocalFile(sCurDocPath, percentDecode(u));
						if(xNyf.fileExists(xSsgFn) && xImgDir.exists()){
							var sLeaf=xSsgFn.getLeafName();
							if(sLeaf){
								var sTmpFn=new CLocalFile(xImgDir.toString(), sLeaf);
								var nBytes=xNyf.exportFile(xSsgFn.toString(), sTmpFn.toString());
								if(nBytes>0){
									platform.deferDeleteFile(sTmpFn);
									u=urlFromLocalFile(sTmpFn);
								}
							}
						}
					}

					return u;
				});
			}

			var vUrls=[]; //2016.5.8 ignore urls, as on pasting it has higher priority than HTML/TEXT;
			{
//				substituteUrisWithinHtml(sHtml, 'a', function(sObj, sTagName){
//					var u=sObj.toString();
//					if(vUrls.indexOf(u)<0) vUrls.push(u);
//					return u;
//				});
			}

			var sDataType='', vMimeData=[];
			{
				if(sHtml){
					if(sDataType) sDataType+=',';
					sDataType+='html';
					vMimeData.push(sHtml);
				}
				if(sTxt){
					if(sDataType) sDataType+=',';
					sDataType+='text';
					vMimeData.push(sTxt);
				}
				if(vUrls.length>0){
					if(sDataType) sDataType+=',';
					sDataType+='urls';
					vMimeData.push(vUrls.join('\n'));
				}
			}

			if(sDataType && vMimeData.length>0){
				platform.setClipboardData(sDataType, vMimeData);
			}
		}

		plugin.destroyProgressBar();

	}else{
		alert(_lc('Prompt.Warn.NoDbOpened', 'No database is currently opened.'));
	}

}catch(e){
	alert(e);
}
