
//sValidation=nyfjs
//sCaption=Custom indent ...
//sHint=Custom indent for the selected paragraphs
//sCategory=MainMenu.Paragraph
//sPosition=PAR-10
//sCondition=CURDB; DBRW; CURINFOITEM; HTMLEDIT
//sID=p.CustomIndent
//sAppVerMin=7.0
//sShortcutKey=
//sAuthor=wjjsoft

/////////////////////////////////////////////////////////////////////
// Extension scripts for myBase Desktop v7.x
// Copyright 2015 Wjj Software. All rights Reserved.
// Website: www.wjjsoft.com  Contact: info@wjjsoft.com
/////////////////////////////////////////////////////////////////////
// This code is property of Wjj Software (WJJSOFT). You may not use it
// for any commercial purpose without preceding consent from authors.
/////////////////////////////////////////////////////////////////////


var _lc=function(sTag, sDef){return plugin.getLocaleMsg(sTag, sDef);};
var _lc2=function(sTag, sDef){return _lc(plugin.getLocaleID()+'.'+sTag, sDef);};

var _trim=function(s){return (s||'').replace(/^\s+|\s+$/g, '');};
var _trim_cr=function(s){return (s||'').replace(/\r+$/g, '');};

try{
	var xNyf=new CNyfDb(-1);

	if(xNyf.isOpen()){

		if(!xNyf.isReadonly()){

			if(plugin.isContentEditable()){

				var _unit_of=function(s){
					return (s||'').replace(/^([e\d\s]+)(?=[a-z%]{0,2}$)/i, '');
				};

				var sCfgKey0 = 'SetTextIndent.iStart', sCfgKey1 = 'SetTextIndent.iLeft', sCfgKey2 = 'SetTextIndent.iRight';

				var vVals=[
					  '|'+_lc('p.Common.Initial', 'Initial')
					, '0px'
					, '0.5em', '1em', '2em', '3em', '4em', '5em', '6em', '7em', '8em', '9em', '10em', '11em', '12em'
					, '5pt', '10pt', '15pt', '20pt', '30pt', '40pt', '50pt', '60pt', '70pt', '80pt', '90pt'
					, '5px', '10px', '15px', '20px', '30px', '40px', '50px', '60px', '70px', '80px', '90px'
				];

				var vFields = [
					{sField: "comboedit", sLabel: _lc2('FirstLine', 'First-line indent'), vItems: vVals, sInit: localStorage.getItem(sCfgKey0)||'', bReq: false}
					, {sField: "comboedit", sLabel: _lc2('Left', 'Left indent'), vItems: vVals, sInit: localStorage.getItem(sCfgKey1)||'', bReq: false}
					, {sField: "comboedit", sLabel: _lc2('Right', 'Right indent'), vItems: vVals, sInit: localStorage.getItem(sCfgKey2)||'', bReq: false}
				];

				var vRes = input(plugin.getScriptTitle(), vFields, {nMinSize: 400});
				if(vRes && vRes.length == 3){

					var sStart=vRes[0];
					var sLeft=vRes[1];
					var sRight=vRes[2];

					localStorage.setItem(sCfgKey0, sStart);
					localStorage.setItem(sCfgKey1, sLeft);
					localStorage.setItem(sCfgKey2, sRight);

					if(sStart != '' && _unit_of(sStart)=='') sStart+='pt';
					if(sLeft != '' && _unit_of(sLeft)=='') sLeft+='pt';
					if(sRight != '' && _unit_of(sRight)=='') sRight+='pt'; 

					var sCode = 'parCssUtil([{key:"text-indent", val:"%START%"}, {key:"margin-left", val:"%LEFT%"}, {key:"margin-right", val:"%RIGHT%"}]);'.replace(/%START%/, sStart).replace(/%LEFT%/, sLeft).replace(/%RIGHT%/, sRight);

					if(plugin.runDomScript(-1, sCode)){
						//done;
					}
				}
			}else{
				alert(_lc('Prompt.Warn.ReadonlyContent', 'Cannot modify the content opened as Readonly.'));
			}

		}else{
			alert(_lc('Prompt.Warn.ReadonlyDb', 'Cannot modify the database opened as Readonly.'));
		}

	}else{
		alert(_lc('Prompt.Warn.NoDbOpened', 'No database is currently opened.'));
	}
}catch(e){
	alert(e);
}
