
//sValidation=nyfjs
//sCaption=Edit HTML source ...
//sHint=Edit or view HTML source of the current content
//sCategory=MainMenu.Edit; Context.HtmlEdit; /Context.Hyperlink; /Context.HtmlView
//sCondition=CURDB; CURINFOITEM
//sID=p.EditHtmlSrc
//sAppVerMin=7.0
//sShortcutKey=
//sAuthor=wjjsoft

/////////////////////////////////////////////////////////////////////
// Extension scripts for myBase Desktop v7.x
// Copyright 2015 Wjj Software. All rights Reserved.
// Website: www.wjjsoft.com  Contact: info@wjjsoft.com
/////////////////////////////////////////////////////////////////////
// This code is property of Wjj Software (WJJSOFT). You may not use it
// for any commercial purpose without preceding consent from authors.
/////////////////////////////////////////////////////////////////////


var _lc=function(sTag, sDef){return plugin.getLocaleMsg(sTag, sDef);};
var _lc2=function(sTag, sDef){return _lc(plugin.getLocaleID()+'.'+sTag, sDef);};

var _trim=function(s){return (s||'').replace(/^\s+|\s+$/g, '');};
var _trim_cr=function(s){return (s||'').replace(/\r+$/g, '');};

try{
	var xNyf=new CNyfDb(-1);

	if(xNyf.isOpen()){

		var xSsgFn=new CLocalFile(plugin.getCurDocFile(-1));
		var sSsgPath=xSsgFn.getDirectory(), sSsgName=xSsgFn.getLeafName(), sExt=xSsgFn.getExtension(false).toLowerCase();
		var sTitle=xNyf.getFolderHint(sSsgPath); if(!sTitle) sTitle='....';
		var vExts='html;htm'.split(';');
		if(vExts.indexOf(sExt)>=0){

			var _cleanup_html_tag=function(sHtml, sTag, bDel){
				var p1=sHtml.toUpperCase().indexOf('<'+sTag.toUpperCase());
				if(p1>=0){
					var p2=sHtml.indexOf('>', p1);
					if(p2>p1){
						if(bDel){
							sHtml=sHtml.substr(0, p1)+sHtml.substr(p2+1);
						}else{
							sHtml=sHtml.substr(0, p1)+'<'+sTag+'>'+sHtml.substr(p2+1);
						}
					}
				}
				return sHtml;
			};

			var _downgrade_xhtml=function(sHtml){
				sHtml=_cleanup_html_tag(sHtml, '!DOCTYPE html', true);
				sHtml=_cleanup_html_tag(sHtml, 'meta', true);
				sHtml=_cleanup_html_tag(sHtml, 'html', false);
				sHtml=_cleanup_html_tag(sHtml, 'body', false);
				return sHtml;
			};

			var sHtml=plugin.getTextContent(-1, true), xShortcutFn, sDocDispName;
			var bShortcut=xNyf.isShortcut(xSsgFn);
			if(bShortcut){
				var sFnSrc=xNyf.getShortcutFile(xSsgFn, true);
				if(sFnSrc){
					xShortcutFn=new CLocalFile(sFnSrc);
					if(xShortcutFn.exists()){
						sDocDispName=sFnSrc;
					}else{
						alert(_lc('Prompt.Failure.FileNotFound', 'File not found.')+'\n\n'+sFnSrc);
					}
				}
			}else{
				sDocDispName=sTitle+'/'+sSsgName;
			}

			if(sDocDispName){
				var bRO=xNyf.isReadonly() || !plugin.isContentEditable();
				var sMsg=_lc2('Descr', 'HTML document') + ": " + sDocDispName;
				sHtml=textbox({
					sTitle: plugin.getScriptTitle()
					, sDescr: sMsg
					, sDefTxt: sHtml
					, bReadonly: bRO
					, bWordwrap: false
					, bRich: false
					, bFind: true
					, bFont: true
					, nWidth: 95
					, nHeight: 80
					, sBtnOK: bRO ? '' : _lc('p.Common.Apply', 'Apply')
					, sSyntax: 'html'
				});

				if(sHtml && !bRO){

					//2014.12.20 setHTML clears the entire DOM including UNDO stack, so it needs to first save if any changes as a history revision for UNDO;
					if(plugin.isContentEditable()) plugin.commitCurrentChanges();

					plugin.setTextContent(-1, sHtml, true);
					plugin.setDomDirty(-1, true);
				}
			}
		}else{
			alert(_lc2('DocTypeUnsupported', 'Can not edit random contents other than HTML documents.')+'\n\n'+sTitle+'/'+sSsgName);
		}

	}else{
		alert(_lc('Prompt.Warn.NoDbOpened', 'No database is currently opened.'));
	}
}catch(e){
	alert(e);
}
