
//sValidation=nyfjs
//sCaption=Syntax highlight ...
//sHint=Syntax highlight the whole or selected source code
//sCategory=MainMenu.Edit; Context.HtmlEdit
//sPosition=
//sCondition=CURDB; DBRW; CURINFOITEM; HTMLEDIT;
//sID=p.SyntaxHighlight
//sAppVerMin=7.0
//sAuthor=wjjsoft

/////////////////////////////////////////////////////////////////////
// Extension scripts for myBase Desktop v7.x
// Copyright 2016 Wjj Software. All rights Reserved.
// Website: www.wjjsoft.com  Contact: info@wjjsoft.com
/////////////////////////////////////////////////////////////////////
// This code is property of Wjj Software (WJJSOFT). You may not use it
// for any commercial purpose without preceding consent from authors.
/////////////////////////////////////////////////////////////////////

//2015.6.6 initial commit by wjj;
//C/C++-like source code supported, such as C/C++, JS, PHP, Java, C#, etc.

//2015.6.6 by gzhaha
//added Python, Perl

//2015.6.7 by gzhaha
//updated R, added ActionScript, Ruby
//efforts on dealing with # symbol within quotation marks: '...#...' or "...#..."

//12:31 6/7/2015
//efforts on dealing with if any html-tags (e.g. <pre>, <code>) in source code

//17:47 6/7/2015
//bugfix with < > operators in source code

//2015.6.8 by gzhaha
//added Delphi, Pig Latin, Bash

//11:41 6/9/2015
//added Cpp/Qt
//deal with HTML entities in source code (&nbsp;, &amp;, &#8195, &#x2003 ...)

//12:24 6/10/2015
//removed the 'HTMLSELECTED' requirement, so it can handle all content in HTML editor without having to first select all lines;

//2015.6.11 by gzhaha
//add js+myBase

//2015.6.12 by gzhaha
//add: substitute for $ character, the issue is related to parse '$' in source code
//add: substitute for the \ character, the issue is related to parse \\ in source code.

//2015.6.14 by gzhaha
//add: Pascal

//2015.6.15 by gzhaha
//add: support multi sets of symbols for block comment.

//16:46 6/15/2015
//updates: added the data structure {start: '', end: ''} to store pairs of block-level remark tags;

//18:28 6/16/2015
//support of objc & RegExp for reversed tags;

//12:00 6/18/2015
//added Apple Swift;

//17:34 6/29/2015
//custom font-family/size for <pre>;

//17:25 8/17/2015
//bugfix: The '<' operator not working in remark blocks;
//added a safe method to generate the special tags for '<>&...', in case that they could appear in source code, e.g. the script itself;

//2016.4.19
//added MathLib: function calls and constants;

var _lc=function(sTag, sDef){return plugin.getLocaleMsg(sTag, sDef);};
var _lc2=function(sTag, sDef){return _lc(plugin.getLocaleID()+'.'+sTag, sDef);};

var _trim=function(s){return (s||'').replace(/^\s+|\s+$/g, '');};
var _trim_cr=function(s){return (s||'').replace(/\r+$/g, '');};

try{
	var xNyf=new CNyfDb(-1);

	if(xNyf.isOpen()){

		if(!xNyf.isReadonly() && plugin.isContentEditable()){

			var sSrc=plugin.getSelectedText(-1, false), bWhole=false;
			if(!sSrc){
				bWhole=true;
				sSrc=plugin.getTextContent(-1, false);
			}

			if(sSrc){

				var xLang={
					  'cpp': 'C/C++'
					, 'cppstl': 'C/C++ with STL'
					, 'cppstlqt': 'C/C++ with STL/Qt'
					, 'java': 'Java'
					, 'cs': 'C#'
					, 'js': 'Javascript'
					, 'jsmybase': 'Javascript with myBase Plugin APIs'
					, 'sql': 'T-SQL'
					, 'php': 'PHP'
					, 'go': 'Google GO'
					, 'gnur': 'GNU/R Language'
					, 'vb': 'Visual Basic'
					, 'py': 'Python'
					, 'pl': 'Perl'
					, 'as': 'ActionScript'
					, 'ruby': 'Ruby'
					, 'delphi': 'Delphi'
					, 'pigla': 'Pig Latin'
					, 'bash': 'Bash'
					, 'pascal': 'Pascal'
					, 'objc': 'Objective-C'
					, 'swift': 'Swift'
					, 'mathlib': 'MathLib'
				};

				var vIDs=[], vLangs=[];
				for(var i in xLang){
					vIDs[vIDs.length]=i;
					vLangs[vLangs.length]=xLang[i];
				}

				//2015.6.29 a list of fixed fonts;
				//http://stackoverflow.com/questions/3995022/pre-tag-and-css-font-family
				//http://www.w3schools.com/cssref/css_websafe_fonts.asp
				var vFonts=[
					'|'+_lc('p.Common.Default', 'Default')
					, 'Lucida Console', 'Courier New', 'Consolas', 'serif'
					, 'Menlo', 'Monaco', 'monospace', 'Liberation Mono'
					, 'DejaVu Sans Mono', 'Bitstream Vera Sans Mono'
					];

				var vSizes=['|'+_lc('p.Common.Default', 'Default')];
				for(var i=8; i<=72; ++i){
					vSizes.push(i+'pt');
					if(i>=20) i+=3;
				}

				var sCfgKey0='SyntaxHighlight.nUses', nUses=parseInt(localStorage.getItem(sCfgKey0)||'');
				var sCfgKey1='SyntaxHighlight.iLang', sCfgKey2='SyntaxHighlight.sFontSize', sCfgKey3='SyntaxHighlight.sBgColor';
				var vFields = [
					{sField: 'combolist', sLabel: _lc2('Language', 'Language'), vItems: vLangs, sInit: localStorage.getItem(sCfgKey1)||''}
					, {sField: 'comboedit', sLabel: _lc2('FontSize', 'Font size'), vItems: vSizes, sInit: localStorage.getItem(sCfgKey2)||(nUses==0 ? c_sFontSizee : ''), bReq: false}
					//, {sField: 'color', sLabel: _lc2('BgColor', 'Back color'), sInit: localStorage.getItem(sCfgKey1)||''}
				];
				var vRes=input(plugin.getScriptTitle(), vFields, {nMinSize: 450, vMargins: [6, 0, 30, 0], bVert: false});
				if(vRes && vRes.length>=2){

					var iLang=vRes[0], sFontSize=vRes[1], sBgColor=''; //vRes[2];

					localStorage.setItem(sCfgKey0, ++nUses);
					localStorage.setItem(sCfgKey1, iLang);
					localStorage.setItem(sCfgKey2, sFontSize);
					localStorage.setItem(sCfgKey3, sBgColor);

					var sLid=vIDs[iLang];

					var sHtml;
					{
						var xFn=new CLocalFile(plugin.getPathToScripts(), 'syntaxhighlight.js');
						var sCode=xFn.loadText('auto');
						if(sCode){
							eval.call(null, sCode);
							sHtml=syntaxHighlight(sSrc, sLid, sFontSize, sBgColor);
						}
					}

					if(sHtml){
						if(bWhole){

							if(plugin.selectAllText){ //2015.6.10 requires latest build b-20;

								plugin.selectAllText();
								plugin.replaceSelectedText(-1, sHtml, true);

							}else{

								//2015.6.10 setHTML clears the entire DOM including UNDO stack, so it needs to first save if any changes as a history revision for Undoable;
								if(plugin.isContentEditable()) plugin.commitCurrentChanges();

								plugin.setTextContent(-1, sHtml, true);
								plugin.setDomDirty(-1, true);

							}

						}else{

							plugin.replaceSelectedText(-1, sHtml, true);

						}
					}
				}

			}else{
				alert(_lc('Prompt.Warn.NoTextSelected', 'No text content is currently selected.'));
			}

		}else{
			alert(_lc('Prompt.Warn.ReadonlyDb', 'Cannot modify the database opened as Readonly.'));
		}

	}else{
		alert(_lc('Prompt.Warn.NoDbOpened', 'No database is currently opened.'));
	}
}catch(e){
	alert(e);
}
